"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgresClient = exports.PostgresClientConnection = exports.PostgresConnectionPool = exports.PostgresStats = exports.FindCommand = exports.InsertCommand = exports.Command = exports.PostgresDatabaseTransaction = exports.__ΩTransactionTypes = exports.__ΩHostType = exports.__ΩConnectionRequest = exports.ConnectionStatus = exports.__ΩConnectionStatus = exports.ResponseParser = exports.readMessageSize = exports.PostgresClientPrepared = exports.__ΩResult = exports.PostgresConnectionError = exports.PostgresError = void 0;
const __ΩError = ['name', 'message', 'stack', 'Error', 'P&4!&4"&4#8Mw$y'];
const __ΩPartial = ['T', 'Partial', 'l+e#!e"!fRb!Pde"!gN#"w"y'];
const __ΩReturnType = ['T', 'args', '', 'ReturnType', 'l>e"!R"RPde#!P"@2"h"!/#qk#\'QRb!Pde"!p)w$y'];
/*@ts-ignore*/
const { __ΩTypeProperty } = require('@deepkit/type');
/*@ts-ignore*/
const { __ΩTypePropertySignature } = require('@deepkit/type');
/*@ts-ignore*/
const { __ΩSelectorState } = require('@deepkit/orm');
/*@ts-ignore*/
const { __ΩReceiveType } = require('@deepkit/type');
/*@ts-ignore*/
const { __ΩPreparedEntity } = require('@deepkit/sql');
/*@ts-ignore*/
const { __ΩTypeClass } = require('@deepkit/type');
/*@ts-ignore*/
const { __ΩTypeObjectLiteral } = require('@deepkit/type');
function __assignType(fn, args) {
    fn.__type = args;
    return fn;
}
var __type0;
var __type1;
var __type2;
var __type3;
var __type4;
var __type5;
var __type6;
var __type7;
var __type8;
var __type9;
var __type10;
var __type11;
var __type12;
var __type13;
var __type14;
var __type15;
var __type16;
var __type17;
var __type18;
var __type19;
var __type20;
var __type21;
var __type22;
var __type23;
var __type24;
const net_1 = require("net");
const core_1 = require("@deepkit/core");
const orm_1 = require("@deepkit/orm");
const type_1 = require("@deepkit/type");
const tls_1 = require("tls");
const config_js_1 = require("./config.js");
const sql_1 = require("@deepkit/sql");
class PostgresError extends orm_1.DatabaseError {
}
exports.PostgresError = PostgresError;
PostgresError.__type = [() => orm_1.DatabaseError, 'PostgresError', 'P7!5w"'];
class PostgresConnectionError extends PostgresError {
}
exports.PostgresConnectionError = PostgresConnectionError;
PostgresConnectionError.__type = [() => PostgresError, 'PostgresConnectionError', 'P7!5w"'];
const __ΩResult = ['rows', 'rowCount', 'Result', 'P"F4!\'4"Mw#y'];
exports.__ΩResult = __ΩResult;
function readUint32BE(data, offset = 0) {
    return data[offset + 3] + (data[offset + 2] * 2 ** 8) + (data[offset + 1] * 2 ** 16) + (data[offset] * 2 ** 24);
}
readUint32BE.__type = ['data', 'offset', () => 0, 'readUint32BE', 'PW2!\'2">#\'/$'];
function readUint16BE(data, offset = 0) {
    return data[offset + 1] + (data[offset] * 2 ** 8);
}
readUint16BE.__type = ['data', 'offset', () => 0, 'readUint16BE', 'PW2!\'2">#\'/$'];
function getPropertyDeserializer(context, property, varName) {
    switch (property.type.kind) {
        case type_1.ReflectionKind.string:
            return `${varName} = decodeUTF8(data, offset + 4, offset + 4 + length)`;
        case type_1.ReflectionKind.number:
            if ((0, type_1.isAutoIncrementType)(property.type)) {
                return `${varName} = length === 4 ? view.getInt32(offset + 4) : view.getInt64(offset + 4)`;
            }
            return `${varName} = length === 4 ? view.getFloat32(offset + 4) : view.getFloat64(offset + 4)`;
        case type_1.ReflectionKind.boolean:
            return `${varName} = data[offset + 4] === 1`;
        case type_1.ReflectionKind.class:
        case type_1.ReflectionKind.union:
        case type_1.ReflectionKind.array:
        case type_1.ReflectionKind.objectLiteral:
            return `${varName} = parseJson(decodeUTF8(data, offset + 4 + 1, offset + 4 + length))`;
        default:
            throw new Error('Unsupported property type ' + property.type);
    }
}
getPropertyDeserializer.__type = [() => core_1.CompilerContext, 'context', () => __ΩTypeProperty, () => __ΩTypePropertySignature, 'property', 'varName', 'getPropertyDeserializer', 'PP7!2"Pn#n$J2%&2&&/\''];
function buildDeserializer(selector) {
    const type = selector.schema.type;
    if (type.kind !== type_1.ReflectionKind.class && type.kind !== type_1.ReflectionKind.objectLiteral) {
        throw new Error('Invalid type for deserialization');
    }
    const context = new core_1.CompilerContext();
    const lines = [];
    const inlineProps = [];
    const assignProps = [];
    context.set({
        DataView,
        decodeUTF8: core_1.decodeUTF8,
        readUint32BE,
        parseJson: JSON.parse,
    });
    const isClass = type.kind === type_1.ReflectionKind.class;
    const handledPropertiesInConstructor = [];
    const constructorArguments = [];
    const preLines = [];
    const postLines = [];
    const v = context.reserveName('v');
    const properties = type.types.map(__assignType(v => [context.reserveVariable(), v], __type0 || (__type0 = ['v', '', 'P"2!"/"'])));
    for (const [varName, property] of properties) {
        if (!(0, type_1.isPropertyType)(property))
            continue;
        lines.push(`
            length = readUint32BE(data, offset);
            ${getPropertyDeserializer(context, property, varName)}
            offset += 4 + length;
        `);
        if (isClass) {
            assignProps.push(`${v}.${(0, type_1.memberNameToString)(property.name)} = ${varName};`);
        }
        else {
            inlineProps.push(`${String(property.name)}: ${varName}`);
        }
    }
    let createObject = '';
    if (isClass) {
        const clazz = type_1.ReflectionClass.from(type.classType);
        const constructor = clazz.getConstructorOrUndefined();
        const classType = context.reserveConst(type.classType);
        if (!clazz.disableConstructor && constructor) {
            handledPropertiesInConstructor.push(...(0, type_1.getDeepConstructorProperties)(type).map(__assignType(v => String(v.name), __type1 || (__type1 = ['v', '', 'P"2!"/"']))));
            const parameters = constructor.getParameters();
            for (const parameter of parameters) {
                if (!parameter.isProperty()) {
                    constructorArguments.push('undefined');
                    continue;
                }
                const property = clazz.getProperty(parameter.getName());
                if (!property)
                    continue;
                //todo handle is skipped
                const entry = properties.find(__assignType(v => v[1] === property, __type2 || (__type2 = ['v', '', 'P"2!"/"'])));
                if (!entry)
                    continue;
                constructorArguments.push(entry[0]);
            }
        }
        if (clazz.disableConstructor) {
            createObject = `Object.create(${classType}.prototype);`;
            for (const property of clazz.getProperties()) {
                if (property.property.kind !== type_1.ReflectionKind.property || property.property.default === undefined)
                    continue;
                const defaultFn = context.reserveConst(property.property.default);
                createObject += `\n${v}.${(0, type_1.memberNameToString)(property.name)} = ${defaultFn}.apply(${v});`;
            }
        }
        else {
            createObject = `new ${classType}(${constructorArguments.join(', ')})`;
            // preLines.push(`const oldCheck = typeSettings.unpopulatedCheck; typeSettings.unpopulatedCheck = UnpopulatedCheck.None;`);
            // postLines.push(`typeSettings.unpopulatedCheck = oldCheck;`);
        }
    }
    else {
        createObject = `{${inlineProps.join(', ')}}`;
    }
    const code = `
    const view = new DataView(data.buffer, data.byteOffset, data.byteLength);
    let offset = 1 + 4 + 2; // Skip type, length, and field count
    let length = 0;

    ${lines.join('\n')}

    ${preLines.join('\n')}
    const ${v} = ${createObject};
    ${assignProps.join('\n')}
    ${postLines.join('\n')}

    result.push(${v});
    `;
    console.log(code);
    return context.build(code, 'data', 'result');
}
buildDeserializer.__type = [() => __ΩSelectorState, 'selector', 'message', 'rows', '', 'buildDeserializer', 'Pn!2"PW2#"F2$$/%/&'];
function buildDeserializerForType(type) {
    if (type.kind !== type_1.ReflectionKind.class && type.kind !== type_1.ReflectionKind.objectLiteral) {
        throw new Error('Invalid type for deserialization');
    }
    const context = new core_1.CompilerContext();
    const lines = [];
    const props = [];
    context.set({
        DataView,
        decodeUTF8: core_1.decodeUTF8,
        readUint32BE,
        parseJson: JSON.parse,
    });
    for (const field of type.types) {
        if (!(0, type_1.isPropertyType)(field))
            continue;
        const varName = context.reserveVariable();
        lines.push(`
            length = readUint32BE(data, offset);
            ${getPropertyDeserializer(context, field, varName)}
            offset += 4 + length;
        `);
        props.push(`${String(field.name)}: ${varName},`);
    }
    const code = `
    const view = new DataView(data.buffer, data.byteOffset, data.byteLength);
    let offset = 1 + 4 + 2; // Skip type, length, and field count
    let length = 0;
    ${lines.join('\n')}

    result.push({
        ${props.join('\n')}
    });
    `;
    return context.build(code, 'data', 'result');
}
buildDeserializerForType.__type = ['Type', 'type', 'message', 'result', '', 'buildDeserializerForType', 'P"w!2"PW2#"F2$$/%/&'];
function buildAutoIncrementDeserializer(type) {
    const schema = type_1.ReflectionClass.fromType(type);
    return buildDeserializerForType({
        kind: type_1.ReflectionKind.objectLiteral,
        types: [
            schema.getPrimary().property,
        ],
    });
}
buildAutoIncrementDeserializer.__type = ['Type', 'type', 'buildAutoIncrementDeserializer', 'P"w!2""/#'];
class PostgresClientPrepared {
    constructor(client, sql, selector, statementName) {
        this.client = client;
        this.sql = sql;
        this.selector = selector;
        this.statementName = statementName;
        this.created = false;
        const serializer = this.selector.schema && this.selector.select.length === 0;
        this.deserialize = serializer
            ? buildDeserializer(this.selector)
            : () => {
            };
    }
    execute(params) {
        // console.log('execute statement', this.statementName, this.sql.slice(0, 100), params.slice(0, 10))   ;
        return (core_1.asyncOperation.Ω = [['"']], (0, core_1.asyncOperation)(__assignType((resolve, reject) => {
            if (!this.created) {
                const oids = params.map(__assignType(param => {
                    if (typeof param === 'number')
                        return 23;
                    if (typeof param === 'boolean')
                        return 16;
                    return 0; // Text
                }, __type3 || (__type3 = ['param', '', 'P"2!"/"'])));
                const message = sendParse(this.statementName, this.sql, oids);
                this.client.write(message);
                this.created = true;
            }
            if (!this.cache) {
                this.cache = Buffer.concat([
                    sendBind('ab', this.statementName, params),
                    sendExecute('ab', 0),
                    syncMessage,
                ]);
            }
            // this.client.write(this.cache);
            //
            // const rows: any[] = [];
            // this.deserialize(empty); //reset state machine
            // this.client.deserialize = (message) => {
            //     try {
            //         const row = this.deserialize(message);
            //         rows.push(row);
            //     } catch (e) {
            //         console.log('e', e);
            //         reject(e);
            //     }
            // };
            // this.client.ready = () => {
            //     resolve({ rows, rowCount: rows.length });
            // };
            // this.client.error = reject;
        }, __type4 || (__type4 = ['resolve', 'reject', '', 'P"2!"2""/#']))));
    }
}
exports.PostgresClientPrepared = PostgresClientPrepared;
PostgresClientPrepared.__type = ['cache', 'message', 'rows', '', 'deserialize', () => PostgresClientConnection, 'client', 'sql', () => __ΩSelectorState, 'selector', 'statementName', 'constructor', 'params', () => __ΩResult, 'execute', 'PostgresClientPrepared', '!3!8PW2""F2#$/$3%PP7&2\':&2(:n)2*:&2+;"0,P"F2-n.`0/5w0'];
const __ΩClient = [() => __ΩReturnType, () => net_1.connect, 'Client', 'i"o!"w#y'];
function int32Buffer(value) {
    const buffer = Buffer.alloc(4);
    buffer.writeUint32BE(value);
    return buffer;
}
int32Buffer.__type = ['value', 'int32Buffer', 'P"2!"/"'];
function int16Buffer(value) {
    const buffer = Buffer.alloc(2);
    buffer.writeUint16BE(value);
    return buffer;
}
int16Buffer.__type = ['value', 'int16Buffer', 'P"2!"/"'];
function sendParse(statementName, query, paramTypeOids) {
    const nameBuffer = Buffer.from(statementName + '\0', 'utf8');
    const queryBuffer = Buffer.from(query + '\0', 'utf8');
    const typeCountBuffer = int16Buffer(paramTypeOids.length);
    const typesBuffer = Buffer.concat(paramTypeOids.map(__assignType(oid => int32Buffer(oid), __type5 || (__type5 = ['oid', '', 'P"2!"/"']))));
    const message = Buffer.concat([
        Buffer.from('P'), // Parse message
        Buffer.from([0, 0, 0, 1]),
        nameBuffer,
        queryBuffer,
        typeCountBuffer,
        typesBuffer,
    ]);
    message.writeUint32BE(message.length - 1, 1);
    return message;
}
sendParse.__type = ['statementName', 'query', 'paramTypeOids', 'sendParse', 'P&2!&2""F2#"/$'];
function sendBind(portalName, statementName, parameters) {
    const portalBuffer = Buffer.from(portalName + '\0', 'utf8');
    const statementBuffer = Buffer.from(statementName + '\0', 'utf8');
    const paramCountBuffer = int16Buffer(parameters.length);
    const paramBuffers = Buffer.concat(parameters.map(__assignType(param => {
        const paramBuffer = Buffer.from(param + '', 'utf8');
        const paramLengthBuffer = int32Buffer(paramBuffer.length);
        return Buffer.concat([paramLengthBuffer, paramBuffer]);
    }, __type6 || (__type6 = ['param', '', 'P"2!"/"']))));
    const message = Buffer.concat([
        Buffer.from('B'), // Bind message
        Buffer.from([0, 0, 0, 1]),
        portalBuffer,
        statementBuffer,
        Buffer.from([0, 1, 0, 0]), // (1, 1) = (amount, text)
        // Buffer.from([0, 1, 0, 1]), // (1, 1) = (amount, binary), Int16 + (Int16[C])
        paramCountBuffer, //Int16
        paramBuffers, //(Int32, Bytes)[]
        Buffer.from([0, 1, 0, 1]), // Result column format codes (1, 1) = (amount, binary), Int16 + (Int16[C])
    ]);
    message.writeUint32BE(message.length - 1, 1);
    return message;
}
sendBind.__type = ['portalName', 'statementName', 'parameters', 'sendBind', 'P&2!&2""F2#"/$'];
function getSimpleQueryBuffer(query) {
    const queryBuffer = Buffer.from(query + '\0', 'utf8');
    const message = Buffer.concat([
        Buffer.from('Q'), // Query message
        int32Buffer(queryBuffer.length + 4),
        queryBuffer,
    ]);
    return message;
}
getSimpleQueryBuffer.__type = ['query', 'getSimpleQueryBuffer', 'P&2!"/"'];
function sendExecute(portalName, maxRows) {
    const portalBuffer = Buffer.from(portalName + '\0', 'utf8');
    const maxRowsBuffer = int32Buffer(maxRows);
    const message = Buffer.concat([
        Buffer.from('E'), // Execute message
        Buffer.from([0, 0, 0, 1]),
        portalBuffer,
        maxRowsBuffer,
    ]);
    message.writeUint32BE(message.length - 1, 1);
    return message;
}
sendExecute.__type = ['portalName', 'maxRows', 'sendExecute', 'P&2!\'2""/#'];
const syncMessage = Buffer.from('S\0\0\0\x04');
function readMessageSize(buffer, offset = 0) {
    return 1 + (buffer[offset + 4] + (buffer[offset + 3] * 2 ** 8) + (buffer[offset + 2] * 2 ** 16) + (buffer[offset + 1] * 2 ** 24));
}
exports.readMessageSize = readMessageSize;
readMessageSize.__type = ['buffer', 'offset', () => 0, 'readMessageSize', 'PPW_J2!\'2">#\'/$'];
class ResponseParser {
    constructor(onMessage) {
        this.onMessage = onMessage;
        this.currentMessageSize = 0;
    }
    feed(data, bytes) {
        if (!data.byteLength)
            return;
        if (!bytes)
            bytes = data.byteLength;
        // console.log('got chunk', data.length);
        if (!this.currentMessage) {
            if (data.byteLength < 5) {
                //not enough data to read the header. Wait for next onData
                return;
            }
            this.currentMessage = data.byteLength === bytes ? data : data.subarray(0, bytes);
            this.currentMessageSize = readMessageSize(data);
        }
        else {
            this.currentMessage = Buffer.concat([this.currentMessage, data.byteLength === bytes ? data : data.subarray(0, bytes)]);
            if (!this.currentMessageSize) {
                if (this.currentMessage.byteLength < 5) {
                    //not enough data to read the header. Wait for next onData
                    return;
                }
                this.currentMessageSize = readMessageSize(this.currentMessage);
            }
        }
        let currentSize = this.currentMessageSize;
        let currentBuffer = this.currentMessage;
        while (currentBuffer) {
            if (currentSize > currentBuffer.byteLength) {
                //important to copy, since the incoming might change its data
                this.currentMessage = currentBuffer;
                // this.currentMessage = currentBuffer;
                this.currentMessageSize = currentSize;
                //message not completely loaded, wait for next onData
                return;
            }
            if (currentSize === currentBuffer.byteLength) {
                //current buffer is exactly the message length
                this.currentMessageSize = 0;
                this.currentMessage = undefined;
                this.onMessage(currentBuffer);
                return;
            }
            if (currentSize < currentBuffer.byteLength) {
                //we have more messages in this buffer. read what is necessary and hop to next loop iteration
                // const message = currentBuffer.subarray(0, currentSize);
                // console.log('onMessage', currentSize, message.length)
                this.onMessage(currentBuffer);
                currentBuffer = currentBuffer.subarray(currentSize);
                // currentBuffer = new Uint8Array(currentBuffer.buffer, currentBuffer.byteOffset + currentSize);
                if (currentBuffer.byteLength < 5) {
                    //not enough data to read the header. Wait for next onData
                    this.currentMessage = currentBuffer;
                    this.currentMessageSize = 0;
                    return;
                }
                const nextCurrentSize = readMessageSize(currentBuffer);
                if (nextCurrentSize <= 0)
                    throw new Error('message size wrong');
                currentSize = nextCurrentSize;
                //buffer and size has been set. consume this message in the next loop iteration
            }
        }
    }
}
exports.ResponseParser = ResponseParser;
ResponseParser.__type = ['currentMessage', 'currentMessageSize', function () { return 0; }, 'response', '', 'onMessage', 'constructor', 'data', 'bytes', 'feed', 'ResponseParser', 'W3!8<\'3"<>#PPW2$$/%2&<9"0\'PW2(\'2)8"0*5w+'];
const __ΩConnectionStatus = ['pending', () => "pending", 'connecting', () => "connecting", 'connected', () => "connected", 'disconnected', () => "disconnected", 'ConnectionStatus', 'PC!>"C#>$C%>&C\'>(Bw)'];
exports.__ΩConnectionStatus = __ΩConnectionStatus;
// /**
//  * @reflection never
//  */
// export class PostgresClient {
//     connectionPromise?: Promise<void>;
//     client?: ReturnType<typeof connect>;
//
//     deserialize: (message: Uint8Array) => void = () => {
//     };
//     ready?: (value: any) => void;
//     error?: (value: any) => void;
//
//     statementId = 0;
//
//     responseParser: ResponseParser;
//
//     constructor(public config: PostgresConfig) {
//         this.responseParser = new ResponseParser(this.onResponse.bind(this));
//     }
//
//     onResponse(data: Uint8Array) {
//         switch (data[0]) {
//             case 0x45: // E
//                 const length = readUint32BE(data, 1);
//                 const error = Buffer.from(data).toString('utf8', 5, length);
//                 if (this.error) this.error(error);
//                 break;
//             case 0x44: // D
//                 this.deserialize(data);
//                 break;
//             case 0x5A: // Z
//                 if (this.ready) this.ready({ rows: [], rowCount: 0 });
//                 break;
//         }
//     }
//
//     // onResponse(data: Uint8Array) {
//     //     // const view = new DataView(data.buffer, data.byteOffset, data.byteLength);
//     //     // const length = view.getUint32(offset + 1);
//     //     // const length = readUint32BE(data, 1);
//     //
//     //     // console.log(`response: ${String.fromCharCode(data[0])}, buffer: ${data.length}, length: ${length}`);
//     //
//     //     const type = String.fromCharCode(data[0]);
//     //     if (type === 'R') {
//     //         // const authType = view.getUint32(offset + 5);
//     //         // console.log(`Authentication Type: ${authType}`);
//     //     } else if (type === 'S') {
//     //         // const content = data.subarray(offset + 5, offset + length);
//     //         // const [param, value] = content.toString().split('\0');
//     //         // console.log(`Parameter: ${param}, Value: ${value}`);
//     //     } else if (type === 'K') {
//     //         // const pid = view.getUint32(offset + 5);
//     //         // const secret = view.getUint32(offset + 9);
//     //         // console.log(`PID: ${pid}, Secret: ${secret}`);
//     //     } else if (type === 'Z') {
//     //         // console.log('Ready for query');
//     //         if (this.ready) this.ready({ rows: [], rowCount: 0 });
//     //     } else if (type === 'E') {
//     //         const length = readUint32BE(data, 1);
//     //         const error = Buffer.from(data).toString('utf8', 5, length);
//     //         // console.log('Error:', error);
//     //         if (this.error) this.error(error);
//     //     } else if (type === 'C') {
//     //         // const commandTag = Buffer.from(data).toString('utf8', offset + 5, offset + length);
//     //         // console.log('Command Complete:', commandTag);
//     //     } else if (type === '2') {
//     //         // console.log('Bind Complete');
//     //     } else if (type === '1') {
//     //         // console.log('Parse Complete');
//     //     } else if (type === 'D') {
//     //         // const columnValues = view.getUint16(offset + 5);
//     //         // console.log('Data Row:', columnValues);
//     //         // for (let i = 0; i < columnValues; i++) {
//     //         //     const length = view.getUint32(offset + 7);
//     //         //     const value = Buffer.from(data).toString('utf8', offset + 11, offset + 11 + length);
//     //         //     console.log(`Column ${i} (${length}): ${value}`,  Buffer.from(data).toString('hex', offset + 11, offset + 11 + length));
//     //         //     offset += 4 + length;
//     //         // }
//     //         this.deserialize(data);
//     //
//     //         // const endOfMessage = offset + length;
//     //         // let fieldOffset = offset + 5; // Skip type and length
//     //
//     //         // while (fieldOffset < endOfMessage) {
//     //         //     const fieldLength = data.readInt32BE(fieldOffset);
//     //         //     const fieldValue = data.toString('utf8', fieldOffset + 4, fieldOffset + 4 + fieldLength);
//     //         //     console.log(`Field: ${fieldValue}`);
//     //         //     fieldOffset += 4 + fieldLength;
//     //         // }
//     //     } else if (type === 'N') {
//     //         // const endOfMessage = offset + length;
//     //         // let fieldOffset = offset + 5; // Skip type and length
//     //         // console.log('Notice Response:');
//     //         // while (fieldOffset < endOfMessage) {
//     //         //     const fieldType = String.fromCharCode(data[fieldOffset]);
//     //         //     const fieldValue = Buffer.from(data).toString('utf8', fieldOffset + 1, endOfMessage).split('\0')[0];
//     //         //     console.log(`${fieldType}: ${fieldValue}`);
//     //         //     fieldOffset += 1 + Buffer.byteLength(fieldValue) + 1; // Move past the field type, value, and null terminator
//     //         // }
//     //     } else {
//     //         console.log('Unknown message type:', type);
//     //     }
//     // }
//
//     protected async doConnect(): Promise<void> {
//         const client = this.client = connect({
//             port: this.config.port || 5432,
//             host: this.config.host || 'localhost',
//         }, () => {
//             const parameters = 'user\0postgres\0database\0postgres\0\0';
//             const protocolVersion = Buffer.from([0x00, 0x03, 0x00, 0x00]); // Version 3.0
//             const totalLength = Buffer.alloc(4);
//             totalLength.writeInt32BE(Buffer.byteLength(parameters) + protocolVersion.length + 4);
//
//             const startupMessage = Buffer.concat([totalLength, protocolVersion, Buffer.from(parameters)]);
//             client.write(startupMessage);
//         });
//
//         client.setNoDelay(true);
//         // client.setKeepAlive(true, 0);
//
//         return asyncOperation<void>((resolve, reject) => {
//             this.ready = resolve;
//             this.error = reject;
//             client.on('data', (data) => {
//                 this.responseParser.feed(data);
//             });
//
//             client.on('end', () => {
//                 console.log('Disconnected from server');
//             });
//         });
//     }
//
//     connect() {
//         if (this.client) return;
//         if (!this.connectionPromise) {
//             this.connectionPromise = this.doConnect();
//         }
//
//         return this.connectionPromise;
//     }
//
//     async query(sql: string, params: any[]): Promise<Result> {
//         await this.connect();
//         return asyncOperation<any>((resolve, reject) => {
//             // const queryString = `${sql}\0`;
//             // const length = Buffer.alloc(4);
//             // length.writeInt32BE(Buffer.byteLength(queryString) + 4); // Length + size of length field
//             // const queryMessage = Buffer.concat([Buffer.from([0x51]), length, Buffer.from(queryString)]);
//             // console.log('Sending query:', sql, params);
//             // this.client!.write(queryMessage);
//
//             const oids = params.map(param => {
//                 if (typeof param === 'number') return 23;
//                 if (typeof param === 'boolean') return 16;
//                 return 0; // Text
//             });
//
//             this.deserialize = (message) => {
//             };
//             this.ready = resolve;
//             this.error = reject;
//
//             // console.log('query', sql.slice(0, 100), params.slice(0, 10));
//             const statement = `s${this.statementId++}`;
//             const message = Buffer.concat([
//                 sendParse(this.client!, statement, sql, oids),
//                 sendBind(this.client!, 'ab', statement, params),
//                 sendExecute(this.client!, 'ab', 0),
//                 syncMessage,
//             ]);
//             this.client!.write(message);
//
//             // resolve({ rows: [], rowCount: 0 });
//         });
//     }
//
//     async prepare(sql: string, selector: SelectorState): Promise<PostgresClientPrepared> {
//         await this.connect();
//         const statement = `s${this.statementId++}`;
//         return new PostgresClientPrepared(this, sql, selector, statement);
//     }
// }
var ConnectionStatus;
(function (ConnectionStatus) {
    ConnectionStatus["pending"] = "pending";
    ConnectionStatus["connecting"] = "connecting";
    ConnectionStatus["connected"] = "connected";
    ConnectionStatus["disconnected"] = "disconnected";
})(ConnectionStatus || (exports.ConnectionStatus = ConnectionStatus = {}));
const __ΩConnectionRequest = ['readonly', 'nearest', 'ConnectionRequest', 'P)4!)4"Mw#y'];
exports.__ΩConnectionRequest = __ΩConnectionRequest;
const __ΩHostType = ['primary', 'secondary', 'HostType', 'PC!C"Bw#'];
exports.__ΩHostType = __ΩHostType;
const __ΩTransactionTypes = ["REPEATABLE READ", "READ COMMITTED", "SERIALIZABLE", 'TransactionTypes', 'P.!.".#Jw$y'];
exports.__ΩTransactionTypes = __ΩTransactionTypes;
class PostgresDatabaseTransaction extends orm_1.DatabaseTransaction {
    /**
     * This is the default for mysql databases.
     */
    repeatableRead() {
        this.setTransaction = 'REPEATABLE READ';
        return this;
    }
    readCommitted() {
        this.setTransaction = 'READ COMMITTED';
        return this;
    }
    serializable() {
        this.setTransaction = 'SERIALIZABLE';
        return this;
    }
    async begin() {
        if (!this.connection)
            return;
        const set = this.setTransaction ? 'SET TRANSACTION ISOLATION LEVEL ' + this.setTransaction + ';' : '';
        // await this.connection.run(set + 'START TRANSACTION');
    }
    async commit() {
        if (!this.connection)
            return;
        if (this.ended)
            throw new Error('Transaction ended already');
        // await this.connection.run('COMMIT');
        this.ended = true;
        this.connection.release();
    }
    async rollback() {
        if (!this.connection)
            return;
        if (this.ended)
            throw new Error('Transaction ended already');
        // await this.connection.run('ROLLBACK');
        this.ended = true;
        this.connection.release();
    }
}
exports.PostgresDatabaseTransaction = PostgresDatabaseTransaction;
PostgresDatabaseTransaction.__type = [() => orm_1.DatabaseTransaction, () => PostgresClientConnection, 'connection', () => __ΩTransactionTypes, 'setTransaction', 'repeatableRead', 'readCommitted', 'serializable', 'begin', 'commit', 'rollback', 'PostgresDatabaseTransaction', 'P7!P7"3#8n$3%8P!0&P!0\'P!0(P"0)P"0*P"0+5w,'];
const __ΩDeserializer = ['message', '', 'Deserializer', 'PW2!"/"w#y'];
function noopDeserializer(message) {
}
noopDeserializer.__type = ['message', 'noopDeserializer', 'PW2!"/"'];
class Command {
    constructor() {
        this.write = () => void 0;
    }
    sendAndWait(message, deserializer = noopDeserializer) {
        this.write(message);
        return (0, core_1.asyncOperation)(__assignType((resolve, reject) => {
            this.current = {
                resolve,
                reject,
                deserializer,
            };
        }, __type7 || (__type7 = ['resolve', 'reject', '', 'P"2!"2""/#'])));
    }
    async query(sql, type = this.query.Ω?.[0]) {
        this.query.Ω = undefined;
        let deserializer = () => {
        };
        if (type) {
            type = (0, type_1.resolveReceiveType)(type);
            const jit = (0, type_1.getTypeJitContainer)(type);
            deserializer = jit.sqlQueryDeserializer;
            if (!deserializer) {
                deserializer = jit.sqlQueryDeserializer = buildDeserializerForType(type);
            }
        }
        const buffer = getSimpleQueryBuffer(sql);
        const rows = [];
        await this.sendAndWait(buffer, __assignType((buffer) => {
            deserializer(buffer, rows);
        }, __type8 || (__type8 = ['buffer', '', 'P"2!"/"'])));
        return rows[0];
    }
    needsWritableHost() {
        return false;
    }
    handleResponse(response) {
        switch (response[0]) {
            case 0x45: { // E
                const length = readUint32BE(response, 1);
                const error = (0, core_1.decodeUTF8)(response, 5, length);
                this.current.reject(error);
                break;
            }
            case 0x44: { // D
                this.current.deserializer(response);
                // const columns = readUint16BE(response, 5);
                // let offset = 1 + 4 + 2;
                // console.log('columns', columns);
                // for (let i = 0; i < columns; i++) {
                //     const length = readUint32BE(response, offset);
                //     console.log('column', i, length, Buffer.from(response).toString('hex', offset + 4, offset + 4 + length));
                //     offset += 4 + length;
                // }
                break;
            }
            case 0x5A: { // Z
                this.current.resolve();
                break;
            }
            default: {
                // console.log('unhandled', String.fromCharCode(response[0]), response);
            }
        }
    }
}
exports.Command = Command;
Command.__type = ['T', () => Function, 'resolve', () => Function, 'reject', () => __ΩDeserializer, 'deserializer', 'current', 'buffer', '', 'write', function () { return () => void 0; }, 'message', () => __ΩDeserializer, () => noopDeserializer, 'sendAndWait', 'sql', () => __ΩReceiveType, 'type', 'query', () => config_js_1.Host, 'host', () => PostgresClientConnection, 'connection', () => PostgresDatabaseTransaction, 'transaction', 'execute', 'needsWritableHost', 'response', 'handleResponse', 'Command', 'b!PPu"4#Pu$4%n&4\'M3(8PW2)$/*3+>,PW2-n.2\'>/$`00P&21e"!o2"238"04PP7526P7728P792:8e"!`0;=P)0<PW2=$0>5w?'];
class InsertCommand extends Command {
    constructor(platform, prepared, items) {
        super();
        this.platform = platform;
        this.prepared = prepared;
        this.items = items;
    }
    async execute(host, client, transaction) {
        // build SQL
        // command: parse
        // command: bind
        // command: execute
        // command: sync
        const names = [];
        const placeholder = new this.platform.placeholderStrategy;
        const scopeSerializer = (0, type_1.getSerializeFunction)(this.prepared.type, this.platform.serializer.serializeRegistry);
        for (const property of this.prepared.fields) {
            if (property.autoIncrement)
                continue;
            names.push(property.columnNameEscaped);
        }
        const placeholders = [];
        const params = [];
        for (const item of this.items) {
            const converted = scopeSerializer(item);
            const values = [];
            for (const property of this.prepared.fields) {
                if (property.autoIncrement)
                    continue;
                values.push(placeholder.getPlaceholder());
                params.push(converted[property.name]);
            }
            placeholders.push(values.join(', '));
        }
        const returning = this.prepared.primaryKey.autoIncrement ? 'RETURNING ' + this.prepared.primaryKey.columnNameEscaped : '';
        const sql = `INSERT INTO ${this.prepared.tableNameEscaped} (${names.join(', ')})
                VALUES (${placeholders.join('), (')}) ${returning}`;
        const statement = '';
        const message = Buffer.concat([
            sendParse(statement, sql, []),
            sendBind('', statement, params),
            sendExecute('', 0),
            syncMessage,
        ]);
        console.log('insert', sql);
        const deserializerAutoIncrement = buildAutoIncrementDeserializer(this.prepared.type);
        const rows = [];
        await this.sendAndWait(message, __assignType((v) => deserializerAutoIncrement(v, rows), __type9 || (__type9 = ['v', '', 'P"2!"/"'])));
        console.log('rows', rows);
        for (let i = 0; i < this.items.length; i++) {
            this.items[i][this.prepared.primaryKey.name] = rows[i][this.prepared.primaryKey.name];
        }
        // parse data rows: auto-incremented columns
        return 0;
    }
}
exports.InsertCommand = InsertCommand;
InsertCommand.__type = [() => Command, () => sql_1.DefaultPlatform, 'platform', () => __ΩPreparedEntity, 'prepared', 'items', 'constructor', () => config_js_1.Host, 'host', () => PostgresClientConnection, 'client', () => PostgresDatabaseTransaction, 'transaction', 'execute', 'InsertCommand', 'P\'7!PP7"2#:n$2%:"F2&:"0\'PP7(2)P7*2+P7,2-8"0.5\'6"w/'];
class FindCommand extends Command {
    constructor(sql, prepared, selector, statementName) {
        super();
        this.sql = sql;
        this.prepared = prepared;
        this.selector = selector;
        this.statementName = statementName;
        this.created = false;
        const serializer = this.selector.select.length === 0;
        this.deserialize = serializer
            ? buildDeserializer(this.selector)
            : () => {
                //todo more complex deserializer
            };
        console.log('new FindCommand', sql);
    }
    setParameters(params) {
        if (!params.length)
            return;
        this.cache = Buffer.concat([
            sendBind('ab', this.statementName, params),
            sendExecute('ab', 0),
            syncMessage,
        ]);
    }
    async execute(host, connection, transaction) {
        if (!this.created) {
            const message = sendParse(this.statementName, this.sql, []);
            this.write(message);
            this.created = true;
        }
        if (!this.cache) {
            this.cache = Buffer.concat([
                sendBind('ab', this.statementName, this.selector.params),
                sendExecute('ab', 0),
                syncMessage,
            ]);
        }
        const rows = [];
        await this.sendAndWait(this.cache, __assignType((data) => {
            try {
                this.deserialize(data, rows);
            }
            catch (e) {
                console.log('deserialize error', e);
                throw e;
            }
        }, __type10 || (__type10 = ['data', '', 'P"2!"/"'])));
        return rows;
    }
}
exports.FindCommand = FindCommand;
FindCommand.__type = ['T', () => Command, 'cache', 'message', 'rows', '', 'deserialize', 'sql', () => __ΩPreparedEntity, 'prepared', () => __ΩSelectorState, 'selector', 'statementName', 'constructor', 'params', 'setParameters', () => config_js_1.Host, 'host', () => PostgresClientConnection, 'connection', () => PostgresDatabaseTransaction, 'transaction', 'execute', 'FindCommand', 'b!Pe"!F7"!3#8PW2$"F2%"/&3\'P&2(:n)2*:n+2,:&2-;"0.P"F2/"00PP7122P7324P75268"075e!!F6"w8'];
const __ΩInRecorveryResponse = ['inRecovery', 'InRecorveryResponse', 'P)4!Mw"y'];
class SelectCommand extends Command {
    constructor(sql, type) {
        super();
        this.sql = sql;
        this.type = type;
    }
    async execute(host, connection, transaction) {
        const res = await this.query(this.sql, this.type);
        return true;
    }
}
SelectCommand.__type = [() => Command, 'sql', () => __ΩTypeClass, () => __ΩTypeObjectLiteral, 'type', 'constructor', () => config_js_1.Host, 'host', () => PostgresClientConnection, 'connection', () => PostgresDatabaseTransaction, 'transaction', 'execute', 'SelectCommand', 'P)7!P&2";Pn#n$J2%8;"0&PP7\'2(P7)2*P7+2,8"0-5)6"w.'];
class HandshakeCommand extends Command {
    async execute(host, connection, transaction) {
        this.host = host;
        const parameters = 'user\0postgres\0database\0postgres\0\0';
        const protocolVersion = Buffer.from([0x00, 0x03, 0x00, 0x00]); // Version 3.0
        const totalLength = Buffer.alloc(4);
        totalLength.writeInt32BE(Buffer.byteLength(parameters) + protocolVersion.length + 4);
        const startupMessage = Buffer.concat([totalLength, protocolVersion, Buffer.from(parameters)]);
        await this.sendAndWait(startupMessage);
        return true;
    }
    handleResponse(response) {
        switch (response[0]) {
            // S
            case 0x53: {
                if (!this.host)
                    break;
                const length = readUint32BE(response, 1);
                const firstNull = response.indexOf(0, 5);
                const name = (0, core_1.decodeUTF8)(response, 5, firstNull);
                const value = (0, core_1.decodeUTF8)(response, firstNull + 1, length);
                this.host.parameters[name] = value;
                if (name === 'in_hot_standby' && value === 'on') {
                    this.host.setType(1 /* HostType.secondary */);
                }
                return;
            }
        }
        super.handleResponse(response);
    }
}
HandshakeCommand.__type = [() => Command, () => config_js_1.Host, 'host', () => config_js_1.Host, () => PostgresClientConnection, 'connection', () => PostgresDatabaseTransaction, 'transaction', 'execute', 'response', 'handleResponse', 'HandshakeCommand', 'P)7!P7"3#8PP7$2#P7%2&P7\'2(8"0)PW2*$0+5)6"w,'];
class PostgresStats {
    constructor() {
        /**
         * How many connections have been created.
         */
        this.connectionsCreated = 0;
        /**
         * How many connections have been reused.
         */
        this.connectionsReused = 0;
        /**
         * How many connection requests were queued because pool was full.
         */
        this.connectionsQueued = 0;
        this.bytesReceived = 0;
        this.bytesSent = 0;
    }
}
exports.PostgresStats = PostgresStats;
PostgresStats.__type = ['connectionsCreated', function () { return 0; }, 'connectionsReused', function () { return 0; }, 'connectionsQueued', function () { return 0; }, 'bytesReceived', function () { return 0; }, 'bytesSent', function () { return 0; }, 'PostgresStats', '\'3!>"\'3#>$\'3%>&\'3\'>(\'3)>*5w+'];
class PostgresConnectionPool {
    constructor(config, stats) {
        this.config = config;
        this.stats = stats;
        this.connectionId = 0;
        /**
         * Connections, might be in any state, not necessarily connected.
         */
        this.connections = [];
        this.cacheHints = {};
        this.queue = [];
    }
    async waitForAllConnectionsToConnect(throws = false) {
        const promises = [];
        for (const connection of this.connections) {
            if (connection.connectingPromise) {
                promises.push(connection.connectingPromise);
            }
        }
        if (!promises.length)
            return;
        // try {
        if (throws) {
            await Promise.all(promises);
        }
        else {
            await Promise.allSettled(promises);
        }
        // } catch (error: any) {
        //     throw new PostgresConnectionError(`Failed to connect: ${formatError(error)}`, { cause: error });
        // }
    }
    async connect() {
        await this.ensureHostsConnected(true);
    }
    close() {
        //import to work on the copy, since Connection.onClose modifies this.connections.
        const connections = this.connections.slice(0);
        for (const connection of connections) {
            connection.close();
        }
    }
    async ensureHostsConnected(throws = false) {
        if (this.ensureHostsConnectedPromise)
            return this.ensureHostsConnectedPromise;
        //make sure each host has at least one connection
        const hosts = await this.config.getHosts();
        for (const host of hosts) {
            if (host.connections.length > 0)
                continue;
            this.newConnection(host);
        }
        return this.ensureHostsConnectedPromise = (0, core_1.asyncOperation)(__assignType(async (resolve) => {
            await this.waitForAllConnectionsToConnect(throws);
            resolve(undefined);
        }, __type11 || (__type11 = ['resolve', '', 'P"2!"/"']))).then(() => {
            this.ensureHostsConnectedPromise = undefined;
        });
    }
    findHostForRequest(hosts, request) {
        //todo, handle request.nearest
        for (const host of hosts) {
            if (!request.readonly && host.isWritable())
                return host;
            if (request.readonly && host.isReadable())
                return host;
        }
        throw new PostgresConnectionError(`Could not find host for connection request. (readonly=${request.readonly}, hosts=${hosts.length}). Last Error: ${this.lastError}`);
    }
    createAdditionalConnectionForRequest(request) {
        const hosts = this.config.hosts;
        const host = this.findHostForRequest(hosts, request);
        return this.newConnection(host);
    }
    newConnection(host) {
        this.stats.connectionsCreated++;
        const connection = new PostgresClientConnection(this.connectionId++, host, this.config, __assignType((connection) => {
            (0, core_1.arrayRemoveItem)(host.connections, connection);
            (0, core_1.arrayRemoveItem)(this.connections, connection);
            //onClose does not automatically reconnect. Only new commands re-establish connections.
        }, __type12 || (__type12 = ['connection', '', 'P"2!"/"'])), __assignType((connection) => {
            this.release(connection);
        }, __type13 || (__type13 = ['connection', '', 'P"2!"/"'])), __assignType((bytesSent) => {
            this.stats.bytesSent += bytesSent;
        }, __type14 || (__type14 = ['bytesSent', '', 'P"2!"/"'])), __assignType((bytesReceived) => {
            this.stats.bytesReceived += bytesReceived;
        }, __type15 || (__type15 = ['bytesReceived', '', 'P"2!"/"'])));
        host.connections.push(connection);
        this.connections.push(connection);
        return connection;
    }
    release(connection) {
        for (let i = 0; i < this.queue.length; i++) {
            const waiter = this.queue[i];
            if (!this.matchRequest(connection, waiter.request))
                continue;
            this.stats.connectionsReused++;
            this.queue.splice(i, 1);
            waiter.resolve(connection);
            //we don't set reserved/set cleanupTimeout,
            //since the connection is already reserved and the timeout
            //is only set when the connection actually is starting idling.
            return;
        }
        connection.reserved = false;
        connection.cleanupTimeout = setTimeout(() => {
            if (this.connections.length <= this.config.options.minPoolSize) {
                return;
            }
            connection.close();
        }, this.config.options.maxIdleTimeMS);
    }
    matchRequest(connection, request) {
        if (!request.readonly && !connection.host.isWritable())
            return false;
        if (!request.readonly) {
            if (connection.host.isSecondary() && !this.config.options.secondaryReadAllowed)
                return false;
            if (!connection.host.isReadable())
                return false;
        }
        return true;
    }
    /**
     * Returns an existing or new connection, that needs to be released once done using it.
     */
    async getConnection(request = {}, cacheHint) {
        const r = Object.assign({ readonly: false, nearest: false }, request);
        if (cacheHint) {
            const connection = this.cacheHints[cacheHint];
            if (connection && connection.isConnected() && !connection.reserved) {
                this.stats.connectionsReused++;
                connection.reserved = true;
                if (connection.cleanupTimeout) {
                    clearTimeout(connection.cleanupTimeout);
                    connection.cleanupTimeout = undefined;
                }
                return connection;
            }
        }
        await this.ensureHostsConnected(true);
        for (const connection of this.connections) {
            if (!connection.isConnected())
                continue;
            if (connection.reserved)
                continue;
            if (request.nearest)
                throw new PostgresConnectionError('Nearest not implemented yet');
            if (!this.matchRequest(connection, r))
                continue;
            this.stats.connectionsReused++;
            connection.reserved = true;
            if (connection.cleanupTimeout) {
                clearTimeout(connection.cleanupTimeout);
                connection.cleanupTimeout = undefined;
            }
            if (cacheHint)
                this.cacheHints[cacheHint] = connection;
            return connection;
        }
        if (this.connections.length < this.config.options.maxPoolSize) {
            const connection = this.createAdditionalConnectionForRequest(r);
            connection.reserved = true;
            if (cacheHint)
                this.cacheHints[cacheHint] = connection;
            return connection;
        }
        return (0, core_1.asyncOperation)(__assignType((resolve) => {
            this.stats.connectionsQueued++;
            this.queue.push({
                resolve: __assignType((connection) => {
                    if (cacheHint)
                        this.cacheHints[cacheHint] = connection;
                    resolve(connection);
                }, __type16 || (__type16 = ['connection', '', 'P"2!"/"'])), request: r,
            });
        }, __type17 || (__type17 = ['resolve', '', 'P"2!"/"'])));
    }
}
exports.PostgresConnectionPool = PostgresConnectionPool;
PostgresConnectionPool.__type = ['connectionId', function () { return 0; }, () => PostgresClientConnection, 'connections', function () { return []; }, () => PostgresClientConnection, 'cacheHints', function () { return {}; }, () => PostgresClientConnection, 'connection', '', 'resolve', () => __ΩConnectionRequest, 'request', 'queue', function () { return []; }, () => __ΩError, 'lastError', () => config_js_1.PostgresClientConfig, 'config', () => PostgresStats, 'stats', 'constructor', 'throws', () => false, 'waitForAllConnectionsToConnect', 'connect', 'close', 'ensureHostsConnectedPromise', () => false, 'ensureHostsConnected', () => config_js_1.Host, 'hosts', () => __ΩConnectionRequest, () => config_js_1.Host, 'findHostForRequest', () => __ΩConnectionRequest, () => PostgresClientConnection, 'createAdditionalConnectionForRequest', () => config_js_1.Host, 'host', () => PostgresClientConnection, 'newConnection', () => PostgresClientConnection, 'release', () => PostgresClientConnection, () => __ΩConnectionRequest, 'matchRequest', () => __ΩPartial, () => __ΩConnectionRequest, () => ({}), 'cacheHint', () => PostgresClientConnection, 'getConnection', 'PostgresConnectionPool', '\'3!<>"P7#F3$>%P&P7&LM3\'<>(PPP7)2*$/+4,n-4.MF3/<>0n1328<PP7324<P7526<"07P)28>9$`0:<P"0;P"0<$`3=8<P)28>>"0?PP7@F2AnB2.P7C0D<PnE2.P7F0G<PP7H2IP7J0K<PP7L2*"0M<PP7N2*nO2.)0P<PnRoQ"2.>S&2T8P7U`0V5wW'];
class PostgresClientConnection {
    constructor(id, host, config, onClose, onRelease, onSent, onReceived) {
        this.id = id;
        this.host = host;
        this.config = config;
        this.onClose = onClose;
        this.onRelease = onRelease;
        this.onSent = onSent;
        this.onReceived = onReceived;
        this.messageId = 0;
        this.status = ConnectionStatus.pending;
        this.bufferSize = 2.5 * 1024 * 1024;
        this.cache = {};
        this.released = false;
        this.activeCommands = 0;
        this.executedCommands = 0;
        this.activeTransaction = false;
        this.reserved = false;
        this.bytesReceived = 0;
        this.bytesSent = 0;
        this.statementId = 0;
        this.boundWrite = this.write.bind(this);
        this.responseParser = new ResponseParser(this.onResponse.bind(this));
        if (this.config.options.ssl === true) {
            const options = {
                host: host.hostname,
                port: host.port,
                timeout: config.options.connectTimeoutMS,
                servername: host.hostname,
            };
            const optional = {
                ca: config.options.tlsCAFile,
                key: config.options.tlsCertificateKeyFile || config.options.tlsCertificateFile,
                cert: config.options.tlsCertificateFile,
                passphrase: config.options.tlsCertificateKeyFilePassword,
                rejectUnauthorized: config.options.rejectUnauthorized,
                crl: config.options.tlsCRLFile,
                checkServerIdentity: config.options.checkServerIdentity ? undefined : () => undefined,
            };
            for (const i in optional) {
                if (optional[i])
                    options[i] = optional[i];
            }
            this.socket = (0, tls_1.connect)(options);
            this.socket.on('data', __assignType((data) => {
                this.bytesReceived += data.byteLength;
                this.onReceived(data.byteLength);
                this.responseParser.feed(data);
            }, __type18 || (__type18 = ['data', '', 'P"2!"/"'])));
        }
        else {
            this.socket = (0, net_1.createConnection)({
                host: host.hostname,
                port: host.port,
                timeout: config.options.connectTimeoutMS,
            });
            this.socket.on('data', __assignType((data) => {
                this.bytesReceived += data.byteLength;
                this.onReceived(data.byteLength);
                this.responseParser.feed(data);
            }, __type19 || (__type19 = ['data', '', 'P"2!"/"'])));
            // const socket = this.socket = turbo.connect(host.port, host.hostname);
            // // this.socket.setNoDelay(true);
            // const buffer = Buffer.allocUnsafe(this.bufferSize);
            //
            // function read() {
            //     socket.read(buffer, onRead);
            // }
            //
            // function onRead(err: any, buf: Buffer, bytes: number) {
            //     if (!bytes) return;
            //     responseParser.feed(buf, bytes);
            //     read();
            // }
            //
            // read();
        }
        //important to catch it, so it doesn't bubble up
        this.connect().catch(__assignType((error) => {
            this.error = error;
            this.socket.end();
            onClose(this);
        }, __type20 || (__type20 = ['error', '', 'P"2!"/"'])));
    }
    getCache(key) {
        return this.cache[key];
    }
    setCache(key, command) {
        this.cache[key] = command;
    }
    isConnected() {
        return this.status === ConnectionStatus.connected;
    }
    isConnecting() {
        return this.status === ConnectionStatus.connecting;
    }
    close() {
        this.status = ConnectionStatus.disconnected;
        this.socket.end();
    }
    run(sql) {
        return this.execute(new SelectCommand(sql));
    }
    query(sql, params) {
        //todo this is not possible since we don't know the parameters types
    }
    prepare(sql, selector) {
        return new PostgresClientPrepared(this, sql, selector, 's' + this.statementId++);
    }
    release() {
        //connections attached to a transaction are not automatically released.
        //only with commit/rollback actions
        if (this.transaction && !this.transaction.ended)
            return;
        if (this.transaction)
            this.transaction = undefined;
        this.released = true;
        this.onRelease(this);
    }
    /**
     * When a full message from the server was received.
     */
    onResponse(message) {
        if (!this.lastCommand)
            throw new PostgresError(`Got a server response without active command`);
        this.lastCommand.command.handleResponse(message);
    }
    /**
     * Puts a command on the queue and executes it when queue is empty.
     * A promise is return that is resolved when executed successfully, or rejected
     * when timed out, parser error, or any other error.
     */
    async execute(command) {
        if (this.status === ConnectionStatus.pending)
            await this.connect();
        if (this.status === ConnectionStatus.disconnected)
            throw new PostgresError('Disconnected');
        if (this.lastCommand && this.lastCommand.promise) {
            await this.lastCommand.promise;
        }
        this.lastCommand = { command };
        this.activeCommands++;
        this.executedCommands++;
        command.write = this.boundWrite;
        try {
            this.lastCommand.promise = command.execute(this.host, this, this.transaction);
            return await this.lastCommand.promise;
        }
        finally {
            this.lastCommand = undefined;
            this.activeCommands--;
        }
    }
    write(message) {
        this.socket.write(message);
        this.bytesSent += message.byteLength;
        this.onSent(message.byteLength);
    }
    async connect() {
        if (this.status === ConnectionStatus.disconnected)
            throw new PostgresConnectionError('Connection disconnected');
        if (this.status !== ConnectionStatus.pending)
            return;
        this.status = ConnectionStatus.connecting;
        this.connectingPromise = (0, core_1.asyncOperation)(__assignType(async (resolve, reject) => {
            this.socket.once('close', __assignType((hadErrors) => {
                this.onClose(this);
                if (this.status !== ConnectionStatus.connecting)
                    return;
                this.status = ConnectionStatus.disconnected;
                reject(new PostgresConnectionError('Connection closed while connecting'));
            }, __type21 || (__type21 = ['hadErrors', '', 'P"2!"/"'])));
            this.socket.once('lookup', __assignType((error) => {
                if (this.status !== ConnectionStatus.connecting)
                    return;
                if (error) {
                    this.connectingPromise = undefined;
                    this.status = ConnectionStatus.disconnected;
                    reject(new PostgresConnectionError((0, core_1.formatError)(error), { cause: error }));
                }
            }, __type22 || (__type22 = ['error', '', 'P"2!"/"'])));
            this.socket.once('error', __assignType((error) => {
                if (this.status !== ConnectionStatus.connecting)
                    return;
                this.connectingPromise = undefined;
                this.status = ConnectionStatus.disconnected;
                reject(new PostgresConnectionError((0, core_1.formatError)(error), { cause: error }));
            }, __type23 || (__type23 = ['error', '', 'P"2!"/"'])));
            if (this.socket.destroyed) {
                this.status = ConnectionStatus.disconnected;
                this.connectingPromise = undefined;
                resolve();
            }
            this.socket.once('ready', async () => {
                if (await this.execute(new HandshakeCommand())) {
                    this.status = ConnectionStatus.connected;
                    this.socket.setTimeout(this.config.options.socketTimeoutMS);
                    this.connectingPromise = undefined;
                    resolve();
                }
                else {
                    this.status = ConnectionStatus.disconnected;
                    this.connectingPromise = undefined;
                    reject(new PostgresConnectionError('Connection error: Could not complete handshake 🤷‍️'));
                }
            });
        }, __type24 || (__type24 = ['resolve', 'reject', '', 'P"2!"2""/#'])));
        return this.connectingPromise;
    }
}
exports.PostgresClientConnection = PostgresClientConnection;
PostgresClientConnection.__type = ['messageId', function () { return 0; }, () => __ΩConnectionStatus, 'status', function () { return ConnectionStatus.pending; }, 'bufferSize', function () { return 2.5 * 1024 * 1024; }, () => Command, 'cache', function () { return {}; }, 'released', function () { return false; }, 'connectingPromise', () => Command, 'command', 'promise', 'lastCommand', 'activeCommands', function () { return 0; }, 'executedCommands', function () { return 0; }, 'activeTransaction', function () { return false; }, 'reserved', function () { return false; }, 'cleanupTimeout', 'socket', () => PostgresDatabaseTransaction, 'transaction', () => ResponseParser, 'responseParser', () => __ΩError, 'error', 'bytesReceived', function () { return 0; }, 'bytesSent', function () { return 0; }, 'statementId', function () { return 0; }, 'id', () => config_js_1.Host, 'host', () => config_js_1.PostgresClientConfig, 'config', () => PostgresClientConnection, 'connection', '', 'onClose', () => PostgresClientConnection, 'onRelease', 'bytes', 'onSent', 'onReceived', 'constructor', 'key', () => Command, 'getCache', () => Command, 'setCache', 'isConnected', 'isConnecting', 'close', 'sql', 'run', 'params', 'query', () => __ΩSelectorState, 'selector', () => PostgresClientPrepared, 'prepare', 'release', 'message', 'onResponse', () => __ΩReturnType, "execute", 'execute', 'write', 'connect', 'PostgresClientConnection', '\'3!<>"n#3$>%\'3&>\'P&P#7(LM3)>*)3+>,$`3-8PP#7.4/"`408M318\'32>3\'34>5)36>7)38>9"3:P!!J3;<P7<3=8P7>3?n@3A8\'3B>C\'3D>E\'3F>GP\'2H:P7I2J:9P7K2L<PP7M2N$/O2P<PP7Q2N$/O2R<P\'2S$/O2T<P\'2S$/O2U<"0VP&2WPP#7X-J0YP&2WP#7Z2/"0[P"0\\P"0]P"0^P&2_"`0`P&2_"2a"0bP&2_nc2dP7e0fP"0gPW2h"0i<P"2/".kfoj"`0lPW2h"0mP$`0n5wo'];
class PostgresClient {
    constructor(options) {
        this.stats = new PostgresStats();
        this.config = 'string' === typeof options ? new config_js_1.PostgresClientConfig(options) : options;
        this.pool = new PostgresConnectionPool(this.config, this.stats);
    }
    /**
     * Returns an existing or new connection, that needs to be released once done using it.
     */
    async getConnection(request = {}, transaction) {
        if (transaction && transaction.connection)
            return transaction.connection;
        const connection = await this.pool.getConnection(request);
        //todo check if this is correct and align with mongo
        if (transaction) {
            transaction.connection = connection;
            connection.transaction = transaction;
            try {
                await transaction.begin();
            }
            catch (error) {
                transaction.ended = true;
                connection.release();
                throw new Error('Could not start transaction: ' + error);
            }
        }
        return connection;
    }
}
exports.PostgresClient = PostgresClient;
PostgresClient.__type = [() => PostgresConnectionPool, 'pool', () => PostgresStats, 'stats', function () { return new PostgresStats(); }, () => config_js_1.PostgresClientConfig, 'config', () => config_js_1.PostgresClientConfig, 'options', 'constructor', () => __ΩPartial, () => __ΩConnectionRequest, 'request', () => ({}), () => PostgresDatabaseTransaction, 'transaction', () => PostgresClientConnection, 'getConnection', 'PostgresClient', 'P7!3"P7#3$>%P7&3\'PPP7(&J2)"0*Pn,o+"2->.P7/208P71`025w3'];
//# sourceMappingURL=client.js.map